#
# Altera mif  (memory initilization file) code to standard VHDL RAM type
# by Minas Dasygenis
# 2012
#
#This file is protected with the BSD license.
#
#Usage: awk -f mif2vhdl.awk < input > output
#
BEGIN { num=0 ;OFS=":"}
BEGIN { printf("LIBRARY ieee;\nUSE ieee.std_logic_1164.all;\nUSE ieee.std_logic_arith.all;\n\n")}
BEGIN { printf("Entity ram is\n\tgeneric ( w : integer := XX;r : integer := 7);\n\tport (\n\t\taddress : in std_logic_vector(r-1 downto 0);\n\t\tclock : in std_logic ;\n\t\tq : out std_logic_vector (w-1 downto 0));\n\tend ram;\n\n\n")}
BEGIN { printf("architecture syn of ram is\n\ttype ram_type is array (2**r-1 downto 0)\n\tof std_logic_vector (w-1 downto 0);\nconstant ROM_array : ram_type :=(\n")}

 $1 ~ /^\[..*$/ && match ( $0, /\.\.([0-9]*)/  )   {last=0+substr($0,RSTART+2, RLENGTH-2);  for(i=num;i<last+1;i++) { printf("\"00000000\", --NOP\n")}; num=last}  
 $1 ~ /^[0-9][0-9]*$/ { {printf("\"%s\b\",--%s %s\n", $3,$5,$6)} ; num++ }
END { printf(");\n\n\nbegin\n\tq <= ROM_array(conv_integer(unsigned(address)))\nend syn;\n") }
